import greenfoot.*;  // (Actor, World, Greenfoot, GreenfootImage)

public class DungeonFloor extends World
{
    /**
     * Create the DungeonFloor. Our world has a size 
     * of 575x576 cells, where every cell is just 1 pixel.
     */
    public DungeonFloor() 
    {
        super(575, 576, 1);
        placeSlime();
        populateWorld();
    }
    
    /**
     * Randomly Place Gold 
     */
    public void placeSlime()
    {
        int i = getObjects(Slime.class).size();
        do
        {
           addObject(new Slime(), Greenfoot.getRandomNumber(560), Greenfoot.getRandomNumber(560));
          i++;
        }
        while (i < 3);
    }
    
    /**
     * Create the objects for the start of the game.
     */
    public void populateWorld()
    {
        //DungeonMaster//
        addObject(new DungeonMaster(), 285, 285);
        
        
        //Gold Piles in the open//
        addObject(new Gold(), 503,289);
        addObject(new Gold(), 289,74);
        addObject(new Gold(), 289,505);
        addObject(new Gold(), 70,289);
        

        
        //Top Right Room//
        addObject(new VWall(), 379,69);
        addObject(new VWall(), 379,139);
        addObject(new HWall(), 433,157);
        addObject(new Gold(), 430,73);
        addObject(new Gold(), 430,113);
        
        //Top Left Room//
        addObject(new VWall(), 198,69);
        addObject(new VWall(), 198,139);
        addObject(new HWall(), 145,157);
        addObject(new Gold(), 144,73);
        
        //Bottom Left Room//
        addObject(new VWall(), 199,505);
        addObject(new VWall(), 199,433);
        addObject(new HWall(), 146,415);
        addObject(new Gold(), 143,504);
        
        //Bottom Right Room//
        addObject(new VWall(), 379,505);
        addObject(new VWall(), 379,433);
        addObject(new HWall(), 433,415);
        addObject(new Gold(), 503,507);
        addObject(new Gold(), 144,463);
        
        //top wall//
        addObject(new HWall(), 37,17);
        addObject(new HWall(), 109,17);
        addObject(new HWall(), 181,17);
        addObject(new HWall(), 253,17);
        addObject(new HWall(), 325,17);
        addObject(new HWall(), 397,17);
        addObject(new HWall(), 469,17);
        addObject(new HWall(), 541,17);
        addObject(new HWall(), 613,17);
        
        //left wall//
        addObject(new VWall(), 18,37);
        addObject(new VWall(), 18,109);
        addObject(new VWall(), 18,181);
        addObject(new VWall(), 18,253);
        addObject(new VWall(), 18,325);
        addObject(new VWall(), 18,397);
        addObject(new VWall(), 18,469);
        addObject(new VWall(), 18,541);
        addObject(new VWall(), 18,613);
        
        //rightwall//
        addObject(new VWall(), 557,37);
        addObject(new VWall(), 557,109);
        addObject(new VWall(), 557,181);
        addObject(new VWall(), 557,253);
        addObject(new VWall(), 557,325);
        addObject(new VWall(), 557,397);
        addObject(new VWall(), 557,469);
        addObject(new VWall(), 557,541);
        addObject(new VWall(), 557,613);
        
        //bottom wall//
        addObject(new HWall(), 37,559);
        addObject(new HWall(), 109,559);
        addObject(new HWall(), 181,559);
        addObject(new HWall(), 253,559);
        addObject(new HWall(), 325,559);
        addObject(new HWall(), 397,559);
        addObject(new HWall(), 469,559);
        addObject(new HWall(), 541,559);
        addObject(new HWall(), 613,559);
    }
}
}