import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class DungeonMaster here.
 * 
 * @author Martin Osburn 
 * @version 2.0 June 16, 2013
 */
public class DungeonMaster extends Human
{
    private int vSpeed = 0;
    private int acceleration = 2;
    private int speed = 2;
    
    private GreenfootImage run1r = new GreenfootImage("DungeonMaster-Right1.png");
    private GreenfootImage run2r = new GreenfootImage("DungeonMaster-Right2.png");
    private GreenfootImage run3r = new GreenfootImage("DungeonMaster-Right3.png");
    private GreenfootImage run4r = new GreenfootImage("DungeonMaster-Right4.png");
    private GreenfootImage run1l = new GreenfootImage("DungeonMaster-Left1.png");
    private GreenfootImage run2l = new GreenfootImage("DungeonMaster-Left2.png");
    private GreenfootImage run3l = new GreenfootImage("DungeonMaster-Left3.png");
    private GreenfootImage run4l = new GreenfootImage("DungeonMaster-Left4.png");
    
    private int frame = 1;
    private int animationCounter = 0;
    private int goldEaten;
    
     /** 
     * Act - do whatever the DungeonMaster wants to do. This method is called whenever
     *  the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        checkKeypressR();
        checkKeypressL();
        checkKeypressU();
        checkKeypressD();
        checkWallAbove();
        checkWallBelow();
        checkRightWalls();
        checkLeftWalls();
        lookForGold();
        animationCounter++;
    }
        
    /**
     * Check whether Right Arrow Key have been Pressed
     */
    public void checkKeypressR()
    //When the right key is pressed down, the player moves to the right
    {
       if(Greenfoot.isKeyDown("right"))
       {
           moveRight();
       }
    }
    
    public void moveRight()
    {
      setLocation(getX()+speed, getY());
      if(animationCounter % 4 == 0)
      animateRight();
    }
    
    public void animateRight()
        //This only shows animation for the Dungeon Master moving to the Right
    {
       if(frame == 1)
       {
           setImage(run1r);

        }
        else if(frame == 2)
        {
            setImage(run2r);
        }
        else if(frame == 3)
        {
            setImage(run3r);
        }
        else if(frame == 4)
        {
            setImage(run4r);
            frame = 1;
        }
        
        frame ++;
        return;
    }
   
    /**
     * Check whether Left Arrow Key have been Pressed
     */
    public void checkKeypressL()
    //When the left key is pressed down, the player moves to the left
    {
       if(Greenfoot.isKeyDown("left"))
       {
           moveLeft();
       }
    }
    
    public void moveLeft()
    {
      setLocation(getX()-speed, getY());
      if(animationCounter % 4 == 0)
      animateLeft();
    }
    
    public void animateLeft()
    //This only shows animation for the Dungeon Master moving to the Left
    {
       if(frame == 1)
       {
           setImage(run1l);

        }
        else if(frame == 2)
        {
            setImage(run2l);
        }
        else if(frame == 3)
        {
            setImage(run3l);
        }
        else if(frame == 4)
        {
            setImage(run4l);
            frame = 1;
        }
        frame ++;
        return;
    }
    
    /**
     * Check whether Up Arrow Key have been Pressed
     */
    public void checkKeypressU()
    //When the up key is pressed down, the player moves up
    {
       if(Greenfoot.isKeyDown("up"))
       {
           moveUp();
       }
    }
    
    public void moveUp()
    {
      setLocation(getX(), getY() - speed);
      if(animationCounter % 4 == 0)
      animateRight();
    }
    
    /**
     * Check whether Down Arrow Key have been Pressed
     */
    public void checkKeypressD()
    //When the down key is pressed down, the player moves up
    {
       if(Greenfoot.isKeyDown("down"))
       {
           moveDown();
       }
    }
    
    public void moveDown()
    {
      setLocation(getX(), getY() + speed);
      if(animationCounter % 4 == 0)
      animateRight();
    }
   
/**
* Check if there is a wall above DungeonMaster.
*/
public boolean checkWallAbove()
{
    int spriteHeight = getImage().getHeight();
    int yDistance = (int) (spriteHeight / -2);

    Actor ceiling = getOneObjectAtOffset (0, yDistance, HWall.class);
    if(ceiling != null)
    {
        vSpeed =1;
        bopHead(ceiling);
        return true;
    } 
    else
    {

        return false;
    }

}

public void bopHead(Actor ceiling)
{
    int ceilingHeight = ceiling.getImage().getHeight();
    int newY = ceiling.getY() + (ceilingHeight + getImage().getHeight() /2);

    setLocation(getX(), newY);  
}

/**
* Move to Ground Command to work in conjuction with checkWallBelow.
*/
public void moveToGround(Actor ground)
{
    int groundHeight = ground.getImage().getHeight();
    int newY = ground.getY() - (groundHeight + getImage().getHeight())/2;
    
    setLocation(getX(),newY);
}

/**
* Check if there is a wall below DungeonMaster.
*/
public boolean checkWallBelow()
{
    int spriteHeight = getImage().getHeight();
    int yDistance = (int) (spriteHeight / -2 + 5);

    Actor floor = getOneObjectAtOffset (0, getImage().getHeight()/2, HWall.class);
    if(floor == null)
    {
        return false;
    } 
    else
    {
        moveToGround(floor);
        return true;
    }

}

public void bopFeet(Actor floor)
{
    int floorHeight = floor.getImage().getHeight();
    int newY = floor.getY() - (floorHeight + getImage().getHeight() /2);

    setLocation(getX(), newY);  
}

 /**
     * Check if there is a wall to the right of DungeonMaster.
     */
    public boolean checkRightWalls()
{
    int spriteWidth = getImage().getWidth();
    int xDistance = (int) (spriteWidth/2);
    
    Actor rightWall = getOneObjectAtOffset (xDistance, 0, VWall.class);
    
   if(rightWall == null)
   {
       return false;
   }
   else
   {
       stopByRightWall(rightWall);
       return true;
   }
}

public void stopByRightWall (Actor rightWall)
{
    int wallWidth = rightWall.getImage().getWidth();
    int newX = rightWall.getX() -(wallWidth + getImage().getWidth())/2;
    
    setLocation(newX -5, getY());
}

 /**
 * Check if there is a wall to the left of DungeonMaster.
 */
    public boolean checkLeftWalls()
{
    int spriteWidth = getImage().getWidth();
    int xDistance = (int) (spriteWidth/2);
    
    Actor leftWall = getOneObjectAtOffset (-xDistance, 0, VWall.class);
    
   if(leftWall == null)
   {
       return false;
   }
   else
   {
       stopByLeftWall(leftWall);
       return true;
   }
}

public void stopByLeftWall (Actor leftWall)
{
    int wallWidth = leftWall.getImage().getWidth();
    int newX = leftWall.getX() +(wallWidth + getImage().getWidth())/2;
    
    setLocation(newX +5, getY());
}


/**
* Check whether we have stumbled upon a Gold.
* If we have, eat it. If not, do nothing. If we h   ave
* eaten ten gold, we win.
*/
public void lookForGold()
{
    if ( canSee(Gold.class) ) 
        {
        eat(Gold.class);
            Greenfoot.playSound("chime.wav");
            
            goldEaten = goldEaten + 1;
            if (goldEaten == 10) 
            {
                Greenfoot.playSound("cheering.wav");
                Greenfoot.stop();
            }
        }
}
}

    